<?php
namespace OrganizationsManagement\Factory;

use Doctrine\ORM\EntityManager;

class OmCentralCallbackAssinaturaFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getRotaCallbackCertsign (array $params) {
        $sql = "SELECT CA.ID AS ID_CENTR_ASSINA, RCA.DSURLBASE, RCA.DSROTAASSINAT, RCA.CLIENT_ID, RCA.CLIENT_SECRET
                  FROM CENTRALIZA_ASSINATURA CA
                  JOIN ROTAS_CENTR_ASSINATURA RCA
                    ON RCA.DSCHAVEASSINAT = CA.DSCHAVEASSINAT
                 WHERE CA.IDDOCASSINAT = :IDDOCASSINAT
                   AND CA.NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function inserirLogAssinaturaDigital(array $params) {
        $sql = "INSERT INTO LOG_CENTR_ASSINATURA (
                    ID, ID_CENTR_ASSINA, IDDOCASSINAT, NRCPFSIGNATARIO,  IDACEITARECUSA,
                    DSLOG, NRORG, NRORGINCLUSAO, DTINCLUSAO
                )
                VALUES (
                    :ID, :ID_CENTR_ASSINA,  :IDDOCASSINAT, :NRCPFSIGNATARIO, :IDACEITARECUSA,
                    :DSLOG, :NRORG, :NRORG, SYSDATE
                )";
        
        $ps = $this->connection->prepare($sql);
        $ps->execute($params);
    }

}
?>