CREATE OR REPLACE PROCEDURE VENDA_GPS
AS
   V_DTMOVIM      DATE;
   V_CHAVESEQUNIC VARCHAR2(20);
   V_IDINTERFACE  NUMBER;
   V_QTREGS       NUMBER;
BEGIN
   V_DTMOVIM := TRUNC(SYSDATE)-1;

   FOR C_FILIAL IN
      (SELECT CDFILIAL, NRINSJURFILI
         FROM FILIAL
       ORDER BY CDFILIAL) LOOP

      FOR C_FECHA IN
         (SELECT T.CDFILIAL, C.CDLOJA, T.CDCAIXA, T.DTABERCAIX, T.DTMOVTURCAIX, E.CDTIPORECE, E.NMTIPORECE, E.IDTIPORECE,
                 DECODE(C.IDTPEMISSAOFOS, 'ECF', 'E', DECODE(C.IDTPEMISSAOFOS, 'FNC', 'N', DECODE(C.IDTPEMISSAOFOS, 'SAT', 'S', NULL))) AS ORIGEM,
                 SUM(DECODE(M.IDTIPOMOVIVE, 'S', -M.VRMOVIVEND, M.VRMOVIVEND)) AS VRMOVIVEND
            FROM TURCAIXA T, MOVCAIXA M, TIPORECE E, CAIXA C
           WHERE T.CDFILIAL      = C_FILIAL.CDFILIAL
             AND T.DTMOVTURCAIX >= V_DTMOVIM
             AND T.DTFECHCAIX IS NOT NULL
             AND T.CDFILIAL      = C.CDFILIAL
             AND T.CDCAIXA       = C.CDCAIXA
             AND T.CDFILIAL      = M.CDFILIAL
             AND T.CDCAIXA       = M.CDCAIXA
             AND T.DTABERCAIX    = M.DTABERCAIX
             AND M.CDTIPORECE    = E.CDTIPORECE
             AND M.IDTIPOMOVIVE IN ('E','T','S')
             AND NVL(T.IDINTEGFECHAGPS,'N') <> 'S'
          GROUP BY T.CDFILIAL, C.CDLOJA, T.CDCAIXA, T.DTABERCAIX, T.DTMOVTURCAIX, E.CDTIPORECE, E.NMTIPORECE, E.IDTIPORECE,
                   DECODE(C.IDTPEMISSAOFOS, 'ECF', 'E', DECODE(C.IDTPEMISSAOFOS, 'FNC', 'N', DECODE(C.IDTPEMISSAOFOS, 'SAT', 'S', NULL)))) LOOP

         SELECT COUNT(*)
           INTO V_QTREGS
           FROM FECHAMENTODIA_INT
          WHERE CDFILIAL     = C_FECHA.CDFILIAL
            AND CDCAIXA      = C_FECHA.CDCAIXA
            AND DTMOVIMCAIXA = C_FECHA.DTMOVTURCAIX
            AND CDTIPORECE   = C_FECHA.CDTIPORECE;

         IF V_QTREGS = 0 THEN
            V_IDINTERFACE  := USR_SAP_IDINTERFACE.NEXTVAL;

            INSERT INTO FECHAMENTODIA_INT
               (NRINSJURFILI, CDFILIAL, CDLOJA, NRECFREDZ, CDCAIXA, DTMOVIMCAIXA, VRMOVIVEND,
                CDTIPORECE, NMTIPORECE, IDTIPORECE, ORIGEM, IDINTERFACE, TPINTERFACE, DTINTERFACEORI,
                DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, TMPSTATUS, DTTMPIDA, DTTMPVOLTA, OBSLOG, LOTETMP)
            VALUES
               (C_FILIAL.NRINSJURFILI, C_FECHA.CDFILIAL, C_FECHA.CDLOJA, NULL, C_FECHA.CDCAIXA, C_FECHA.DTMOVTURCAIX, C_FECHA.VRMOVIVEND,
                C_FECHA.CDTIPORECE, C_FECHA.NMTIPORECE, C_FECHA.IDTIPORECE, C_FECHA.ORIGEM, V_IDINTERFACE, 'I', SYSDATE,
                NULL, 1, 1, 2, NULL, NULL, NULL, NULL, NULL);
         ELSE
            UPDATE FECHAMENTODIA_INT
               SET VRMOVIVEND   = VRMOVIVEND + C_FECHA.VRMOVIVEND
             WHERE CDFILIAL     = C_FECHA.CDFILIAL
               AND CDCAIXA      = C_FECHA.CDCAIXA
               AND DTMOVIMCAIXA = C_FECHA.DTMOVTURCAIX
               AND CDTIPORECE   = C_FECHA.CDTIPORECE;
         END IF;

         UPDATE TURCAIXA
            SET IDINTEGFECHAGPS = 'S'
          WHERE CDFILIAL   = C_FECHA.CDFILIAL
            AND CDCAIXA    = C_FECHA.CDCAIXA
            AND DTABERCAIX = C_FECHA.DTABERCAIX;
      END LOOP;

      FOR C_VENDAS IN
         (SELECT V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, V.DTENTRVENDA, V.DTVENDA, V.NRCUPOMFIS, V.CDSERIESAT, V.CDSERIENFCE, V.NRNOTAFISCALCE,
                 V.NRACESSONFCE, V.NRPROTOCOLONFCE, V.NRACESSOCANC, 'N' AS ICMSSOBREGORJETA, V.NRINSCRCONS, V.NMCONSVEND, V.IDSTATUSNFCE, V.IDSITUVENDA,
                 DECODE(V.IDTPEMISVEND, 'N', '65', DECODE(V.IDTPEMISVEND, 'S', '59', NULL)) AS MOD, DECODE(V.IDTPEMISVEND, 'E', NULL, V.IDTPEMISVEND) AS ORIGEM,
                 SUM(TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRTOTCUPOM,
                 SUM(NVL(I.VRDESITVEND,0)) AS VRTOTDESC,
                 SUM(NVL(I.VRACRITVEND,0)) AS VRTOTACRE,
                 SUM(DECODE(I.IDPRODTAXASERV, 'N', NVL(I.VRRATTXSERV,0), NVL(I.VRACRITVEND,0))) AS VRTOTGORJETA
            FROM VENDA V, ITEMVENDA I
           WHERE V.CDFILIAL     = C_FILIAL.CDFILIAL
             AND V.DTENTRVENDA >= V_DTMOVIM
             AND V.CDFILIAL     = I.CDFILIAL
             AND V.CDCAIXA      = I.CDCAIXA
             AND V.NRSEQVENDA   = I.NRSEQVENDA
             AND V.IDSITUVENDA IN ('O','C')
             AND ((V.IDTPEMISVEND IN ('N','S') AND V.IDSTATUSNFCE IN ('A','C','D')) OR (V.IDTPEMISVEND = 'E'))
             AND NVL(V.IDINTEGVENDAGPS,'N') <> 'S'
             AND SYSDATE > V.DTEXPVENDA + (3600/86400)
          GROUP BY V.CDFILIAL, V.CDLOJA, V.CDCAIXA, V.NRSEQVENDA, V.DTENTRVENDA, V.DTVENDA, V.NRCUPOMFIS, V.CDSERIESAT, V.CDSERIENFCE,
                   V.NRNOTAFISCALCE, V.NRACESSONFCE, V.NRPROTOCOLONFCE, V.NRACESSOCANC, V.NRINSCRCONS, V.NMCONSVEND, V.IDSTATUSNFCE, V.IDSITUVENDA,
                   DECODE(V.IDTPEMISVEND, 'N', '65', DECODE(V.IDTPEMISVEND, 'S', '59', NULL)), DECODE(V.IDTPEMISVEND, 'E', NULL, V.IDTPEMISVEND)) LOOP

         NOVO_CODIGO('CUPOM_INT', V_CHAVESEQUNIC, 1);
         V_IDINTERFACE  := USR_SAP_IDINTERFACE.NEXTVAL;

         INSERT INTO CUPOM_INT
            (CHAVESEQUNIC, NRINSJURFILI, CDFILIAL, CDLOJA, NRECFREDZ, CDCAIXA, DTENTRVENDA, DTEMISSAO,
             NRCUPOMFIS, CDSERIESAT, CDSERIENFCE, NRNOTAFISCALCE, NRACESSONFCE, MOD, NRPROTOCOLONFCE,
             NRACESSOCANC, VRTOTCUPOM, VRTOTDESC, VRTOTACRE, VRTOTGORJETA, ICMSSOBREGORJETA,
             NRINSCRCONS, NMCONSVEND, IDSTATUSNFCE, IDSITUVENDA, ORIGEM, IDINTERFACE, TPINTERFACE,
             DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, TMPSTATUS, DTTMPIDA, DTTMPVOLTA, OBSLOG, LOTETMP)
         VALUES
            (V_CHAVESEQUNIC, C_FILIAL.NRINSJURFILI, C_VENDAS.CDFILIAL, C_VENDAS.CDLOJA, NULL, C_VENDAS.CDCAIXA, C_VENDAS.DTENTRVENDA, C_VENDAS.DTVENDA,
             C_VENDAS.NRCUPOMFIS, C_VENDAS.CDSERIESAT, C_VENDAS.CDSERIENFCE, C_VENDAS.NRNOTAFISCALCE, C_VENDAS.NRACESSONFCE, C_VENDAS.MOD, C_VENDAS.NRPROTOCOLONFCE,
             C_VENDAS.NRACESSOCANC, C_VENDAS.VRTOTCUPOM, C_VENDAS.VRTOTDESC, C_VENDAS.VRTOTACRE, C_VENDAS.VRTOTGORJETA, C_VENDAS.ICMSSOBREGORJETA,
             C_VENDAS.NRINSCRCONS, C_VENDAS.NMCONSVEND, C_VENDAS.IDSTATUSNFCE, C_VENDAS.IDSITUVENDA, C_VENDAS.ORIGEM, V_IDINTERFACE, 'I',
             SYSDATE, NULL, 1, 1, 2, NULL, NULL, NULL, NULL, NULL);

         FOR C_ITENS IN
            (SELECT I.NRORDITCUPFIS, P.CDCLASFISC, P.CDPRODUTO, P.NMPRODUTO, I.QTPRODVEND, I.VRUNITVEND+NVL(I.VRUNITVENDCL,0) AS VRUNITARIO,
                    I.VRDESITVEND, I.VRACRITVEND, 'O' AS IDSITUITEM, O.CDIMPOSTO, T.SGIMPOSTO, O.VRBASECALCICMS, O.VRPEALPRODIT, O.VRIMPOPRODIT,
                    O.IDMODALBASECALC, O.VRBASECALCREDUZ, O.VRIMPOPRODREDUZ, O.CDCSTPRODI, O.CDCSTPRODPC, O.CDCFOPPROD, O.VRPERCOFINS, O.VRIMPCOFINS,
                    O.VRPERPIS, O.VRIMPPIS, TRUNC(I.QTPRODVEND * (I.VRUNITVEND + NVL(I.VRUNITVENDCL,0)),2) - NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0) AS VRTOTITEM
               FROM ITEMVENDA I, ITVENDAIMPOS O, PRODUTO P, IMPOSTO T
              WHERE I.CDFILIAL     = C_VENDAS.CDFILIAL
                AND I.CDCAIXA      = C_VENDAS.CDCAIXA
                AND I.NRSEQVENDA   = C_VENDAS.NRSEQVENDA
                AND I.CDFILIAL     = O.CDFILIAL
                AND I.CDCAIXA      = O.CDCAIXA
                AND I.NRSEQVENDA   = O.NRSEQVENDA
                AND I.NRSEQUITVEND = O.NRSEQUITVEND
                AND I.CDPRODUTO    = P.CDPRODUTO
                AND O.CDIMPOSTO    = T.CDIMPOSTO
             UNION ALL
             SELECT I.NRORDITCUPFISCA, P.CDCLASFISC, P.CDPRODUTO, P.NMPRODUTO, I.QTPRODVENDC, I.VRUNITVENDC+NVL(I.VRUNITVENCLC,0) AS VRUNITVEND,
                    I.VRDESITVENDC, I.VRACRITVENDC, 'C' AS IDSITUITEM, NULL CDIMPOSTO, NULL SGIMPOSTO, NULL VRBASECALCICMS, NULL VRPEALPRODIT, NULL VRIMPOPRODIT,
                    NULL IDMODALBASECALC, NULL VRBASECALCREDUZ, NULL VRIMPOPRODREDUZ, NULL CDCSTPRODI, NULL CDCSTPRODPC, NULL CDCFOPPROD, NULL VRPERCOFINS, NULL VRIMPCOFINS,
                    NULL VRPERPIS, NULL VRIMPPIS, TRUNC(I.QTPRODVENDC * (I.VRUNITVENDC + NVL(I.VRUNITVENCLC,0)),2) - NVL(I.VRDESITVENDC,0) + NVL(I.VRACRITVENDC,0) AS VRTOTITEM
               FROM ITVENDACAN I, PRODUTO P
              WHERE I.CDFILIAL   = C_VENDAS.CDFILIAL
                AND I.CDCAIXA    = C_VENDAS.CDCAIXA
                AND I.NRSEQVENDA = C_VENDAS.NRSEQVENDA
                AND I.CDPRODUTO  = P.CDPRODUTO) LOOP

            V_IDINTERFACE  := USR_SAP_IDINTERFACE.NEXTVAL;

            INSERT INTO ITEMCUPOM_INT
               (CHAVESEQUNIC, NRSEQUITVEND, CDPRODNCM, CDPRODUTO, NMPRODUTO, QTPRODVEND, VRUNITARIO,
                VRDESITVEND, VRACRITVEND, VRTOTITEM, IDSITUITEM, CDIMPOSTO, SGIMPOSTO, VRBASECALC,
                VRPEALPRODIT, VRIMPOPRODIT, IDMODALBASECALC, VRBASECALCREDUZ, VRIMPOPRODREDUZ, CDCSTPRODI,
                CDCSTPRODPC, CDCFOPPROD, VRPERCOFINS, VRIMPOCOFINS, VRPERPIS, VRIMPOPIS, IDINTERFACE, TPINTERFACE,
                DTINTERFACEORI, DTINTERFACEDEST, STATUS, APPORIGEM, APPDESTINO, TMPSTATUS, DTTMPIDA, DTTMPVOLTA, OBSLOG, LOTETMP)
            VALUES
               (V_CHAVESEQUNIC, SUBSTR(C_ITENS.NRORDITCUPFIS,3,3), C_ITENS.CDCLASFISC, C_ITENS.CDPRODUTO, C_ITENS.NMPRODUTO, C_ITENS.QTPRODVEND, C_ITENS.VRUNITARIO,
                C_ITENS.VRDESITVEND, C_ITENS.VRACRITVEND, C_ITENS.VRTOTITEM, C_ITENS.IDSITUITEM, C_ITENS.CDIMPOSTO, C_ITENS.SGIMPOSTO, C_ITENS.VRBASECALCICMS,
                C_ITENS.VRPEALPRODIT, C_ITENS.VRIMPOPRODIT, C_ITENS.IDMODALBASECALC, C_ITENS.VRBASECALCREDUZ, C_ITENS.VRIMPOPRODREDUZ, C_ITENS.CDCSTPRODI,
                C_ITENS.CDCSTPRODPC, C_ITENS.CDCFOPPROD, C_ITENS.VRPERCOFINS, C_ITENS.VRIMPCOFINS, C_ITENS.VRPERPIS, C_ITENS.VRIMPPIS, V_IDINTERFACE, 'I',
                SYSDATE, NULL, 1, 1, 2, NULL, NULL, NULL, NULL, NULL);
         END LOOP;

         FOR C_PAG IN
            (SELECT M.NRSEQUMOVI, M.IDTIPOMOVIVEAUX, M.VRMOVIVEND, T.CDADMINCART, T.CDBANCARTCR,
                    DECODE(M.NRCARTBANCO, NULL, '2', '1') AS TPINTEGRA, T.CDTIPORECE, T.NMTIPORECE, T.IDTIPORECE
               FROM MOVCAIXA M, TIPORECE T
              WHERE M.CDFILIAL   = C_VENDAS.CDFILIAL
                AND M.CDCAIXA    = C_VENDAS.CDCAIXA
                AND M.NRSEQVENDA = C_VENDAS.NRSEQVENDA
                AND M.CDTIPORECE = T.CDTIPORECE) LOOP

            V_IDINTERFACE  := USR_SAP_IDINTERFACE.NEXTVAL;

            INSERT INTO PAGCUPOM_INT
               (CHAVESEQUNIC, NRSEQUMOVI, IDTIPOMOVIVE, VRMOVIVEND, CDADMINCART, CDBANCARTCR, TPINTEGRA,
                CDTIPORECE, NMTIPORECE, IDTIPORECE, IDINTERFACE, TPINTERFACE, DTINTERFACEORI, DTINTERFACEDEST,
                STATUS, APPORIGEM, APPDESTINO, TMPSTATUS, DTTMPIDA, DTTMPVOLTA, OBSLOG, LOTETMP)
            VALUES
               (V_CHAVESEQUNIC, C_PAG.NRSEQUMOVI, C_PAG.IDTIPOMOVIVEAUX, C_PAG.VRMOVIVEND, C_PAG.CDADMINCART, C_PAG.CDBANCARTCR, C_PAG.TPINTEGRA,
                C_PAG.CDTIPORECE, C_PAG.NMTIPORECE, C_PAG.IDTIPORECE, V_IDINTERFACE, 'I', SYSDATE, NULL,
                1, 1, 2, NULL, NULL, NULL, NULL, NULL);
         END LOOP;

         UPDATE VENDA
            SET IDINTEGVENDAGPS = 'S'
          WHERE CDFILIAL   = C_VENDAS.CDFILIAL
            AND CDCAIXA    = C_VENDAS.CDCAIXA
            AND NRSEQVENDA = C_VENDAS.NRSEQVENDA;
      END LOOP;

      COMMIT; /* COMMIT POR FILIAL */

   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('VENDA_GPS','6.49.067'); END;
/
